use crate::prelude::*;

#[repr(C)]
pub union VkAccelerationStructureGeometryDataKHR {
    pub triangles: VkAccelerationStructureGeometryTrianglesDataKHR,
    pub aabbs: VkAccelerationStructureGeometryAabbsDataKHR,
    pub instances: VkAccelerationStructureGeometryInstancesDataKHR,
}

impl From<VkAccelerationStructureGeometryTrianglesDataKHR>
    for VkAccelerationStructureGeometryDataKHR
{
    fn from(triangles: VkAccelerationStructureGeometryTrianglesDataKHR) -> Self {
        VkAccelerationStructureGeometryDataKHR { triangles }
    }
}

impl From<VkAccelerationStructureGeometryAabbsDataKHR> for VkAccelerationStructureGeometryDataKHR {
    fn from(aabbs: VkAccelerationStructureGeometryAabbsDataKHR) -> Self {
        VkAccelerationStructureGeometryDataKHR { aabbs }
    }
}

impl From<VkAccelerationStructureGeometryInstancesDataKHR>
    for VkAccelerationStructureGeometryDataKHR
{
    fn from(instances: VkAccelerationStructureGeometryInstancesDataKHR) -> Self {
        VkAccelerationStructureGeometryDataKHR { instances }
    }
}
